#include <stdio.h>
#include <conio.h>
#include <bios.h>
#include <dos.h>
#include <stdlib.h>

char far diskpfr[512];

int main( int argc, char *argv[] )
{
   unsigned status = 0, i;
   struct diskinfo_t di;
   struct diskfree_t df;
   unsigned char far *p;
   unsigned int part;

   if( argc != 2 )
   {
      printf( "  Syntax: boot <Laufwerk>" );
      exit( 1 );
   }

   if( (di.drive = toupper( argv[1][0] ) - 'A' ) > 1 )
   {
    printf( "Eingabefehler! Laufwerk (A: oder B:) angeben.\n" );
    exit( 1 );
   }
   di.head     = 0;
   di.track    = 0;
   di.sector   = 1;
   di.nsectors = 1;
   di.buffer   = diskpfr;

/* maximal drei Leseversuche */
   for( i = 0; i < 3; i++ )
   {
      status = _bios_disk( _DISK_READ, &di ) >> 8;
      if( !status )
	 break;
   }

/* Einen Sektor anzeigen. */
   if( status )
       printf( "Fehler: 0x%.2x\n", status );
   else
   {
    p = diskpfr + 508;
    printf( "\nOffset 508, alter Wert: %.2x %.2x\n\n", *p, *(p+1));
    printf( "Bitte die gewnschte Bootpartition angeben:\n");
    printf( "1 --> /dev/hda1 \n");
    printf( "2 --> /dev/hda2 \n");
    printf( "3 --> /dev/hda3 \n");
    printf( "4 --> /dev/hda4 \n");
    printf( "5 --> /dev/hdb1 \n");
    printf( "6 --> /dev/hdb2 \n");
    printf( "7 --> /dev/hdb3 \n");
    printf( "8 --> /dev/hdb4 \n\n");
    printf( "Gewnschte Bootpartition? :");
    part = getche() - 48;

    if (part <= 4)
       { *p     = part;
	 *(p+1) = 3;
       }
      else if (part <= 8)
      {
	 *p     = 0x3C + part;
	 *(p+1) = 3;
      }
      else
	 {
	  printf("\nFehlerhafte Eingabe!\n");
	  exit(1);
	 }

/* maximal drei Schreibversuche */
   for( i = 0; i < 3; i++ )
   {
      status = _bios_disk( _DISK_WRITE, &di ) >> 8;
      if( status )
	  printf( "\nFehler: 0x%.2x\n", status );
   }
 }
exit( 1 );
}

